using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Diagnostic
{
    public partial class Diagnostic : Form
    {
        // Global Variable
        private MXCommon_WebReference.MXCommon MX_Common;
        private MSXExxxx_WebReference.MSXExxxx MSXExxxx;
        private MXCommon_WebReference.DefaultResponse MXResponse;
        private MSXExxxx_WebReference.DefaultResponse Response;
        private GroupBox[] g_ChannelGroups = new GroupBox[8];
        private CheckBox[] g_Channels = new CheckBox[16];
        private Label[] g_ChannelInfo = new Label[16];
        private ulong g_ulNbrOfChannels = 0;

        public Diagnostic()
        {
            InitializeComponent();
        }

        private void Diagnostic_Load(object sender, EventArgs e)
        {
            MX_Common = new MXCommon_WebReference.MXCommon();
            MSXExxxx = new MSXExxxx_WebReference.MSXExxxx();
            MX_Common.Timeout = 5000;
            MSXExxxx.Timeout = 5000;

            // Save the check box
            g_Channels[0] = CB_Channel0;
            g_Channels[1] = CB_Channel1;
            g_Channels[2] = CB_Channel2;
            g_Channels[3] = CB_Channel3;
            g_Channels[4] = CB_Channel4;
            g_Channels[5] = CB_Channel5;
            g_Channels[6] = CB_Channel6;
            g_Channels[7] = CB_Channel7;
            g_Channels[8] = CB_Channel8;
            g_Channels[9] = CB_Channel9;
            g_Channels[10] = CB_Channel10;
            g_Channels[11] = CB_Channel11;
            g_Channels[12] = CB_Channel12;
            g_Channels[13] = CB_Channel13;
            g_Channels[14] = CB_Channel14;
            g_Channels[15] = CB_Channel15;


            g_ChannelGroups[0] = GB_Group0;
            g_ChannelGroups[1] = GB_Group1;
            g_ChannelGroups[2] = GB_Group2;
            g_ChannelGroups[3] = GB_Group3;
            g_ChannelGroups[4] = GB_Group4;
            g_ChannelGroups[5] = GB_Group5;
            g_ChannelGroups[6] = GB_Group6;
            g_ChannelGroups[7] = GB_Group7;

            g_ChannelInfo[0] = L_TypeCh0;
            g_ChannelInfo[1] = L_TypeCh1;
            g_ChannelInfo[2] = L_TypeCh2;
            g_ChannelInfo[3] = L_TypeCh3;
            g_ChannelInfo[4] = L_TypeCh4;
            g_ChannelInfo[5] = L_TypeCh5;
            g_ChannelInfo[6] = L_TypeCh6;
            g_ChannelInfo[7] = L_TypeCh7;
            g_ChannelInfo[8] = L_TypeCh8;
            g_ChannelInfo[9] = L_TypeCh9;
            g_ChannelInfo[10] = L_TypeCh10;
            g_ChannelInfo[11] = L_TypeCh11;
            g_ChannelInfo[12] = L_TypeCh12;
            g_ChannelInfo[13] = L_TypeCh13;
            g_ChannelInfo[14] = L_TypeCh14;
            g_ChannelInfo[15] = L_TypeCh15;



            GB_ChannelDiagnostic.Enabled = false;

        }

        private void B_Connect_Click(object sender, EventArgs e)
        {
            System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
            byte[] pcName = new byte[255];
            UInt64 ulValue = 0;
            String [] s_Status = {"OK",
                                  "Voltage line open",
                                  "Voltage line short circuit",
                                  "Current line open",
                                  "Current line short circuit",
                                  "TC disconnected",
                                  "CJC disconnected (M12 connector not present)",
                                  "Sensor front-end disconnected (wiring properly linked)"};


            if ((TB_IPAddress_0.Text.ToString() == "") || (TB_IPAddress_1.Text.ToString() == "") || (TB_IPAddress_2.Text.ToString() == "") || (TB_IPAddress_3.Text.ToString() == ""))
            {
                MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256))
                {
                    if ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256))
                    {
                        if ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256))
                        {
                            if ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256))
                            {
                                MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
                                MSXExxxx.Url = MX_Common.Url;

                                // Get the module type
                                try
                                {
                                    MXResponse = MX_Common.GetModuleType(out pcName);
                                    if (MXResponse.iReturnValue != 0)
                                    {
                                        MessageBox.Show("GetModuleType Error : " + MXResponse.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                        return;
                                    }

                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("GetModuleType Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    return;
                                }


                                try
                                {
                                    Response = MSXExxxx.TemperatureGetNumberOfChannels(0, out g_ulNbrOfChannels);
                                    if (Response.iReturnValue != 0)
                                    {
                                        MessageBox.Show("TemperatureGetNumberOfChannels Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                        return;
                                    }

                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("AcquisitionGetNumberOfChannels Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    return;
                                }

                                for (ulong i = 0; i < g_ulNbrOfChannels; i++)
                                {
                                    g_Channels[i].Enabled = true;
                                    g_Channels[i].Checked = true;
                                    g_ChannelGroups[i / 2].Enabled = true;
                                }

                                for (ulong i = g_ulNbrOfChannels; i < 16; i++)
                                {
                                    g_Channels[i].Enabled = false;
                                    g_Channels[i].Checked = false;
                                    g_ChannelGroups[i / 2].Enabled = false;
                                }

                                try
                                {
                                    for (ulong i = 0; i < g_ulNbrOfChannels; i++)
                                    {

                                        Response = MSXExxxx.TemperatureDiagnostic(i, 0, out ulValue);
                                        if (Response.iReturnValue != 0)
                                        {
                                            MessageBox.Show("TemperatureDiagnostic Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                            return;
                                        }
                                        if (ulValue < (UInt64)s_Status.GetLength(0))
                                            g_ChannelInfo[i].Text = s_Status[ulValue];
                                        else
                                            g_ChannelInfo[i].Text = "Unknown error";
                                    }

                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("TemperatureDiagnostic Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    return;
                                }

                                GB_ChannelDiagnostic.Enabled = true;
                            }
                            else
                            {
                                MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        else
                        {
                            MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                    else
                    {
                        MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                else
                {
                    MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }

        }

  
    }
}