using System;
using System.Collections.Generic;
using System.Text;

namespace TransducerConfiguration
{
    public class Transducer
    {
        public ulong index;
        public string name;
        public ulong type;
        public double veff;
        public double range;
        public double sensitivity;
        public ulong frequency;
        public ulong impedance;
        public ulong calibrated;

        public Transducer(ulong index, string name, ulong type, double veff, double range, double sensitivity, ulong frequency, ulong impedance, ulong calibrated)
        {
            this.index = index;
            this.name = name;
            this.type = type;
            this.veff = veff;
            this.range = range;
            this.sensitivity = sensitivity;
            this.frequency = frequency;
            this.impedance = impedance;
            this.calibrated = calibrated;
        }

        public string Type
        {
            get
            {
                switch (this.type)
                {
                    case 0:
                        return "HB";
                    case 1:
                        return "LVDT";
                    case 2:
                        return "MAHR-HB";
                    case 3:
                        return "MAHR-LVDT";
                    default:
                        return "UNKNOWN";
                }
            }
        }
    }
}
